/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################








#pragma message("Compiling tasandid_server_stdafx.h - this should happen just once per project.\n")



///see http://www.boost.org/libs/spirit/doc/subrules.html
#pragma inline_depth (255)
#pragma inline_recursion (on)

//#pragma pointers_to_members (best_case, single_inheritance)		 ///see http://www.codeproject.com/cpp/FastDelegate.asp
//#pragma pointers_to_members (best_case, multiple_inheritance)		///multiple_inheritance needed by boost::archive::binary_oarchive





#define _CRT_SECURE_NO_WARNINGS
#define _SECURE_SCL 0			   ///throw away all VS security related enhancements.



#if _DEBUG
	#define _CRTDBG_MAP_ALLOC
#endif
#define _MFC_OVERRIDES_NEW








#define NET_DECLARE_ONLY

#define USE_CUSTOM_MEMORY_MANAGER





#define _WIN32_WINNT 0x0400			  //neccessary for myEvent.h





#pragma optimize ("gt", on)		  ///Enable global optimizations. Specify fast sequences of machine code.






///#define _CRTDBG_MAP_ALLOC			   //detect memory leaks
#include <stdlib.h>
#include <crtdbg.h>





///for chart_datastructures.h

	#pragma warning (push)
	#pragma warning (disable: 4244 4267)
	#pragma warning (disable: 4100 4512 6011 6326 6334)				   ///roland


		#include <boost/archive/binary_iarchive.hpp>					  ///must be included before other serialization headers
		#include <boost/archive/binary_oarchive.hpp>					  ///must be included before other serialization headers

		#include <boost/serialization/list.hpp>					///for nonlinear assoc_cell
		#include <boost/serialization/vector.hpp>			   ///for future
		#include <boost/serialization/map.hpp>					///for nonlinear assoc_cell
		
		#include <boost/serialization/split_member.hpp>		   ///Splitting serialize into save/load for nonlinear assoc_cell

		#include <boost/serialization/base_object.hpp>
		
		#include <boost/serialization/export.hpp>			   ///manual registration of classes	// export.hpp header should be last;



	/*
	#include <boost/serialization/list.hpp>	
	#include <boost/serialization/vector.hpp>
	#include <boost/serialization/map.hpp>
	*/

	//#include <boost/serialization/access.hpp>

	//class boost::serialization::access;

	///#pragma warning (default: 4100 4512 4244 4267)				   ///roland
	#pragma warning (pop)



	//#include <boost/preprocessor/stringize.hpp>		 ///general messages
	#include <boost/preprocessor.hpp> 





	#define BOOST_PARAMETER_MAX_ARITY	10
	#include <boost/parameter.hpp>
	
	
	
	#include <boost/bind.hpp>


	#pragma warning (push)
	#pragma warning (disable : 6334)						  ///warning C6334: sizeof operator applied to an expression with an operator might yield unexpected results	
	#include <boost/function.hpp>
	#pragma warning (pop)




																	
#if 0
	#pragma warning (disable: 4100 4512 4244 4267)				   //roland

	#include <boost/archive/binary_oarchive.hpp>					  //must be included before other serialization headers

	#pragma warning (default: 4100 4512 4244 4267)				   //roland


	//#include <ostream>
	#include <sstream>
	//#include <fstream>
#endif



/*
void save_innercells_data(const CHART_DATA_STRUCT_A &data_out) 
{
	std::ofstream ofs("net_assoc_lines.dat");
	boost::archive::binary_oarchive oa(ofs);
	oa << data_out;
}
  */


/*
#pragma warning (disable: 4100 4512 4244 4267)				   //roland

#include <boost/archive/binary_iarchive.hpp>					  //must be included before other serialization headers
#include <boost/archive/binary_oarchive.hpp>					  //must be included before other serialization headers

#pragma warning (default: 4100 4512 4244 4267)				   //roland
*/





///in our code this warning usually means code logic error, not just performance warning
#pragma warning (error: 4800)    ///warning C4800: 'definitions::S' : forcing value to bool 'true' or 'false' (performance warning)
#pragma warning (error: 4716)	  ///warning C4716  '...' : must return a value

///the following warnings cause compilations eventually to fail with VS claiming "unexpected precompiled header error" 
#pragma warning (error: 4503)	  ///'identifier' : decorated name length exceeded, name was truncated
#pragma warning (error: 4786 4788)		///'identifier' : identifier was truncated to 'number' characters

#pragma warning (error: 4002)				  ///promote to error - too many actual parameters for macro 'identifier'







///for chart_datastructures.h

	#pragma warning (push)
	#pragma warning (disable : 6011)		///warning C6011: Dereferencing NULL pointer '_Myptr': Lines: 108, 111, 112, 122
	#include <string>
	#pragma warning (pop)






//#define NET_DECLARE_ONLY
//namespace tasandid
//{
	//#include "datastructures/chart_datastructures.h"	
	











#include <WinSock2.h>				//roland: winsock2.h must be included before windows.h


#include <windows.h>

#pragma warning (push)
#pragma warning (disable : 6011)		///warning C6011: Dereferencing NULL pointer '_Myptr': Lines: 108, 111, 112, 122
#include <string>
#pragma warning (pop)



#include "../myLog.h"














#define NOMACROS
#define INCLUDE_WINDOWS_H
#include "../../pdcurses/curses.h"
#undef NOMACROS




#if 1
	#include "myEvent.h"
	#include "..\mySocket.h"
	#include "..\myLog.h"
	#include "myException.h"
	#include "..\myHostInfo.h"
	#include "mySemaphore.h"
	#include "myThread.h"
	#include "myThreadArgument.h"
#endif





#include <sstream>
#include <iomanip>			///setprecision



#include <xmmintrin.h>
#include <emmintrin.h>
#include <mmintrin.h>		   ///__mm_max_ss and __mm_min_ss




#include "../../SimRobotCore/Tools/SimMath.h"
//#include "../../Controller/Controller.h"

//#include "../common.h"






///for macros.h
#include <malloc.h>

#include <list>
#include <vector>
#include <map>





void init_memory_pool();
void deinit_memory_pool();





#pragma optimize ("", on)			///When you use the on parameter, it resets the optimizations to those that you specified with the /O compiler option.


